import json

from django.views.decorators.csrf import csrf_exempt
from jsonresponse import to_json

from models import RegisterGateway


def get_list(register, user, **kwargs):
    return register.get_list(user, **kwargs)

def post(register, user, data, **kwargs):
    assert user is not None, 'missing user argument'
    assert isinstance(data, list), 'JSON payload is not a list'
    for row in data:
        assert isinstance(row, dict), 'all elements must be dict'
        assert isinstance(row['name'], unicode)
        assert isinstance(row['transports'], list)
    return register.post(user, data, **kwargs)


@csrf_exempt
@to_json('api')
def json_view(request, slug, **kwargs):
    reg = RegisterGateway.objects.get_slug(slug, request)
    kwargs = {}
    for param in (reg.parameters or ()):
        kwargs[param] = request.GET.get(param)
    user = request.GET.get('user')
    if request.method == 'GET':
        return get_list(reg, user, **kwargs)
    if request.method == 'POST':
        data = json.loads(request.body)
        return post(reg, user, data, **kwargs)
    raise NotImplementedError

