from django.test import TestCase
from django.contrib.auth.models import User, Group
from django.db import transaction

from .models import MessageGateway

class MessageTestCase(TestCase):
    def test_clean_numbers(self):
        self.assertEqual(MessageGateway.clean_numbers(['+ 33 12'], '33'),
            ['+3312'])
        self.assertEqual(MessageGateway.clean_numbers(['0 0 33 12'], '33'),
            ['+3312'])
        self.assertEqual(MessageGateway.clean_numbers(['0 12'], '33'),
            ['+3312'])

    def test_clean_numbers_no_prefix(self):
        self.assertEqual(MessageGateway.clean_numbers(['+ 33 12'], '33', prefix=''),
            ['3312'])
        self.assertEqual(MessageGateway.clean_numbers(['0 0 33 12'], '33', prefix=''),
            ['3312'])
        self.assertEqual(MessageGateway.clean_numbers(['0 12'], '33', prefix=''),
            ['3312'])

